﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Threading;
using System.Windows.Threading;
using System.Windows.Browser;
using System.Reflection;


namespace SL_Load
{
    public partial class MainPage : UserControl
    {
        DispatcherTimer _timer = null;
        long _version = VersionHelper.Version;
        private const string dir = "ClientBin";
        private const string xapfileName = "SL_App.xap";
        private const string dllfileName = "SL_App.dll";
        private const string className = "SL_App.MainPage";
        
        public MainPage()
        {
            InitializeComponent();

            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            _timer = new DispatcherTimer();
            _timer.Interval = new TimeSpan(0, 0, 0, 0, 500);
            _timer.Tick += new EventHandler(_timer_Tick);
            _timer.Start();
        }

        void _timer_Tick(object sender, EventArgs e)
        {
             _version = VersionHelper.Version;
            if (_version > 0) 
            {
                _timer.Stop();
                _timer = null;
                DownloadXapFile(dir + "/" + xapfileName + "?" + _version, className);
            }
        }

        private void DownloadXapFile(string xapUrl, string xapClassName)
        {
            WebClient wc = new WebClient();
            wc.OpenReadCompleted += new OpenReadCompletedEventHandler(wc_OpenReadCompleted);
            wc.DownloadProgressChanged += new DownloadProgressChangedEventHandler(wc_DownloadProgressChanged);
            Uri xapUri = new Uri(HtmlPage.Document.DocumentUri, xapUrl);
            wc.OpenReadAsync(xapUri, xapClassName);
        }


        void wc_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            if (e.Error != null)
                return;

            var url = HtmlPage.Document.DocumentUri.ToString();


            Assembly assembly = AssemblyHelper.GetAssemblyFromXap(e.Result, dllfileName);
            UIElement element = assembly.CreateInstance(e.UserState.ToString()) as UIElement;

            for (int i = this.LayoutRoot.Children.Count - 1; i >= 0; i--)
            {
                UIElement child = this.LayoutRoot.Children[i];
                this.LayoutRoot.Children.Remove(child);
                child = null;
            }

            (App.Current.RootVisual as UserControl).Content = element;
        }


        void wc_DownloadProgressChanged(object sender, DownloadProgressChangedEventArgs e)
        {
            this.txtLoading.Text = "下载进度 " + e.ProgressPercentage + "%";
        }
    }
}
